<template>
  <div id="institutions">
    <b-form class="w-100" method="post">
      <!-- Institution Dropdown -->
      <CoscineFormGroup label-cols-sm="0">
        <multiselect
          id="institutionSelection"
          v-model="selected"
          :placeholder="$t('page.institution.placeholder')"
          :options="options"
          label="displayName"
          track-by="displayName"
          :multiple="false"
          select-label=""
          selected-label=""
          deselect-label=""
        />
      </CoscineFormGroup>
      <b-form-group>
        <!-- Button Back -->
        <b-button @click.prevent="clickBack">
          {{ $t("buttons.back") }}
        </b-button>
        <!-- Button Next -->
        <b-button
          variant="primary"
          :disabled="!selected"
          class="float-end"
          @click="clickNext"
        >
          {{ $t("buttons.next") }}
        </b-button>
      </b-form-group>
    </b-form>
  </div>
</template>

<script lang="ts">
// import the store for current module
import useLoginStore from "../store";
// import the main store
import useMainStore from "@/store/index";
import type { DFNAAIData, DFNAAIInstitution } from "../types";

export default defineComponent({
  emits: {
    closeInstitutionSelection: () => true,
    confirmInstitutionSelection: () => true,
  },

  setup() {
    const mainStore = useMainStore();
    const loginStore = useLoginStore();

    return { mainStore, loginStore };
  },

  data() {
    return {
      isRunningInProduction: false,
      selected: null as DFNAAIInstitution | null,
    };
  },

  computed: {
    locale(): string {
      return this.mainStore.coscine.locale;
    },

    institutions(): DFNAAIData[] {
      return this.loginStore.institutions;
    },

    options(): DFNAAIInstitution[] {
      const options: DFNAAIInstitution[] = [];

      // Add Test Shibboleth when not running in production
      if (!this.isRunningInProduction) {
        const testShibboleth: DFNAAIInstitution = {
          entityId: "https://login-test.rz.rwth-aachen.de/shibboleth",
          displayName: "Test Shibboleth",
        };
        options.push(testShibboleth);
      }

      // Add every other institution
      this.institutions.forEach((institution) => {
        options.push({
          entityId: institution.entityId,
          displayName: institution.displayName[this.locale],
          logo: institution.logo,
        });
      });

      // Sort alphabetically
      options.sort((a: DFNAAIInstitution, b: DFNAAIInstitution) =>
        a.displayName > b.displayName
          ? 1
          : b.displayName > a.displayName
            ? -1
            : 0,
      );
      return options;
    },
  },

  created() {
    this.isRunningInProduction =
      window.location.href.toString().indexOf("d-sp") === -1;
  },

  methods: {
    clickNext() {
      if (this.selected) {
        this.loginStore.storeInstitutionSelection(this.selected);
        this.$emit("confirmInstitutionSelection");
      }
    },
    clickBack() {
      this.$emit("closeInstitutionSelection");
    },
  },
});
</script>
